<?php

declare(strict_types=1);

namespace ZondacryptoPay\Paymentpage\Model\Ui;

use Magento\Framework\Exception\LocalizedException;

class Logo
{
    const LOGO = 'ZondacryptoPay_Paymentpage::images/logo.svg';

    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    private $request;

    /**
     * @var \Magento\Framework\View\Asset\Repository
     */
    private $assetRepository;

    public function __construct(
        \Magento\Framework\App\RequestInterface $request,
        \Magento\Framework\View\Asset\Repository $assetRepository
    ) {
        $this->request = $request;
        $this->assetRepository = $assetRepository;
    }

    /**
     * @return string|null
     */
    public function getUrl()
    {
        try {
            $asset = $this->assetRepository->createAsset(self::LOGO, ['_secure' => $this->request->isSecure()]);
        } catch (LocalizedException $e) {
            return null;
        }

        return $asset->getUrl();
    }
}
